var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import { defaultContext, useInfiniteQuery, useIsFetching, useQuery, useMutation, useIsMutating } from "react-query";
function generateKey(baseQueryKey) {
  return (queryKey) => {
    return [...baseQueryKey, ...queryKey || []];
  };
}
const returnByCondition = (condition) => (returnValue) => condition ? returnValue : void 0;
function createQueryToolkit(queryClient) {
  return (queryKey, queryFn, options = {}) => {
    const {
      passArgsToQueryKey = true,
      queryType = "query",
      defaultOptions
    } = options;
    const isInfiniteQuery = queryType === "infiniteQuery";
    const returnOnQuery = returnByCondition(!isInfiniteQuery);
    const returnOnInfiniteQuery = returnByCondition(isInfiniteQuery);
    const keyGenerator = generateKey(queryKey);
    const getKey = (queryKey2, args) => keyGenerator([
      ...queryKey2 ? queryKey2 : [],
      ...passArgsToQueryKey && args ? args : []
    ]);
    const handleHooks = (hook) => (args, queryOptions) => hook(getKey(queryOptions == null ? void 0 : queryOptions.queryKey, args), queryFn(...args || []), __spreadValues(__spreadValues({
      context: defaultContext
    }, defaultOptions), queryOptions));
    const hooks = {
      useQuery: returnOnQuery(handleHooks(useQuery)),
      useInfiniteQuery: returnOnInfiniteQuery(handleHooks(useInfiniteQuery)),
      useIsFetching: (filters) => useIsFetching(getKey(filters == null ? void 0 : filters.queryKey), filters, {
        context: defaultContext
      })
    };
    const handleFetchFunctions = (path, conditionalReturnFunc) => conditionalReturnFunc((args, options2) => queryClient[path](getKey(options2 == null ? void 0 : options2.queryKey, args), queryFn(...args || []), __spreadValues(__spreadValues({}, defaultOptions), options2)));
    return new Proxy(hooks, {
      get(target, path) {
        if (target[path])
          return target[path];
        switch (path) {
          case "fetchQuery":
          case "prefetchQuery":
            return handleFetchFunctions(path, returnOnQuery);
          case "fetchInfiniteQuery":
          case "prefetchInfiniteQuery":
            return handleFetchFunctions(path, returnOnInfiniteQuery);
          case "getQueryData":
          case "getQueryState":
          case "setQueryData":
            return (queryKey2, ...rest) => queryClient[path](getKey(queryKey2), ...rest);
          default:
            if (!queryClient[path])
              throw new Error("unknown property is given");
            return (...args) => queryClient[path](...args);
        }
      }
    });
  };
}
function createMutationToolkit(queryClient) {
  function createMutation(mutationKey, mutationFn, defaultOptions) {
    const keyGenerator = generateKey(mutationKey);
    const hooks = {
      useMutation: (options) => useMutation(keyGenerator(options == null ? void 0 : options.mutationKey), mutationFn, __spreadValues(__spreadValues({
        context: defaultContext
      }, defaultOptions), options)),
      useIsMutating: (filters, options) => useIsMutating(filters || {}, __spreadValues({
        context: defaultContext
      }, options))
    };
    return new Proxy(hooks, {
      get(target, path) {
        if (target[path])
          return target[path];
        switch (path) {
          case "isMutating":
            return (filters) => queryClient.isMutating(__spreadProps(__spreadValues({}, filters), {
              mutationKey: keyGenerator(filters == null ? void 0 : filters.mutationKey)
            }));
          default:
            throw new Error("unknown property is given");
        }
      }
    });
  }
  return createMutation;
}
export { createMutationToolkit, createQueryToolkit };
